package com.yuandian.dataflow.statemachine.grpc;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.ratis.protocol.RaftPeer;
import org.apache.ratis.protocol.RaftPeerId;
import org.apache.ratis.thirdparty.io.grpc.internal.ManagedChannelImplBuilder;

import com.yuandian.dataflow.proto.ProcessorServerGrpc;
import com.yuandian.dataflow.proto.Processor.PacketsProcessorRequest;
import com.yuandian.dataflow.proto.Processor.PacketsProcessorRequestOrBuilder;
import com.yuandian.dataflow.proto.ProcessorServerGrpc.ProcessorServerBlockingStub;
import com.yuandian.dataflow.proto.ProcessorServerGrpc.ProcessorServerFutureStub;
import com.yuandian.dataflow.statemachine.StateServerFactory;
import com.yuandian.dataflow.statemachine.state.Peer;

import io.grpc.ManagedChannel;
import io.grpc.ManagedChannelBuilder;

public class ProcessorClient {

    private HashMap<Peer, ManagedChannel> peerChannelMap =  new HashMap(); 

    public ProcessorServerBlockingStub getBlockingStub(Peer peer) {
        ManagedChannel channel ;
        synchronized(peerChannelMap) {
            channel =  peerChannelMap.get(peer);
            if(channel == null) {
                var managedChannelBuilder = ManagedChannelBuilder.forAddress(peer.getAddress(), peer.getProcessorPort());
                channel = managedChannelBuilder.maxInboundMessageSize(Integer.MAX_VALUE).usePlaintext().build();
                peerChannelMap.put(peer, channel);
            }
        }
        return ProcessorServerGrpc.newBlockingStub(channel);
    }

    public ProcessorServerFutureStub getFutureStub(Peer peer) {
        ManagedChannel channel ;
        synchronized(peerChannelMap) {
            channel =  peerChannelMap.get(peer);
            if(channel == null) {
                var managedChannelBuilder = ManagedChannelBuilder.forAddress(peer.getAddress(), peer.getProcessorPort());
                channel = managedChannelBuilder.maxInboundMessageSize(Integer.MAX_VALUE).usePlaintext().build();
                peerChannelMap.put(peer, channel);
            }
        }
        
        return ProcessorServerGrpc.newFutureStub(channel);
    }
    
    public static void main(String[] args) {
 
        var managedChannelBuilder = ManagedChannelBuilder.forAddress("10.1.1.117", 60017);
        // var managedChannelBuilder = ManagedChannelBuilder.forAddress("127.0.0.1", 60017);
        var channel = managedChannelBuilder.maxInboundMessageSize(Integer.MAX_VALUE).usePlaintext().build();

        var stub = ProcessorServerGrpc.newBlockingStub(channel);
        
        var request = PacketsProcessorRequest.newBuilder();
        
        
        
        var response = stub.allPackets(request.build());
    }
}
